diff --git a/src/main/java/net/minecraft/core/player/inventory/ContainerDispenser.java b/src/main/java/net/minecraft/core/player/inventory/menu/TrapMenu.java
similarity index 51%
rename from src/main/java/net/minecraft/core/player/inventory/ContainerDispenser.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/TrapMenu.java
index 86f58b3a5..ded9ce91e 100644
--- a/src/main/java/net/minecraft/core/player/inventory/ContainerDispenser.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/TrapMenu.java
@@ -1,37 +1,38 @@
-package net.minecraft.core.player.inventory;
+package net.minecraft.core.player.inventory.menu;
 
 import java.util.List;
 
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.block.entity.TileEntityDispenser;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.entity.DispenserBlockEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.slot.Slot;
 
-public class ContainerDispenser extends Container {
+public class TrapMenu extends AbstractContainerMenu {
 
-	public TileEntityDispenser tileEntity;
+	public DispenserBlockEntity trap;
 	
 	private int dispenserSlotsStart;
 	private int inventorySlotsStart;
 	private int hotbarSlotsStart;
 
-	public ContainerDispenser(IInventory iinventory, TileEntityDispenser tileentitydispenser) {
-		tileEntity = tileentitydispenser;
+	public TrapMenu(Container container, DispenserBlockEntity trap) {
+		this.trap = trap;
 		for (int i = 0; i < 3; i++) {
 			for (int l = 0; l < 3; l++) {
-				addSlot(new Slot(tileentitydispenser, l + i * 3, 62 + l * 18, 17 + i * 18));
+				addSlot(new Slot(trap, l + i * 3, 62 + l * 18, 17 + i * 18));
 			}
 
 		}
 
 		for (int j = 0; j < 3; j++) {
 			for (int i1 = 0; i1 < 9; i1++) {
-				addSlot(new Slot(iinventory, i1 + j * 9 + 9, 8 + i1 * 18, 84 + j * 18));
+				addSlot(new Slot(container, i1 + j * 9 + 9, 8 + i1 * 18, 84 + j * 18));
 			}
 		}
 
 		for (int k = 0; k < 9; k++) {
-			addSlot(new Slot(iinventory, k, 8 + k * 18, 142));
+			addSlot(new Slot(container, k, 8 + k * 18, 142));
 		}
 		
 		dispenserSlotsStart = 0;
@@ -40,26 +41,26 @@ public class ContainerDispenser extends Container {
 	}
 	
 	@Override
-	public boolean isUsableByPlayer(EntityPlayer entityplayer) {
-		return tileEntity.canInteractWith(entityplayer);
+	public boolean stillValid(Player entityplayer) {
+		return trap.stillValid(entityplayer);
 	}
 
 	@Override
-	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, EntityPlayer player) {
-		if(slot.id >= dispenserSlotsStart && slot.id < inventorySlotsStart) {
+	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+		if(slot.index >= dispenserSlotsStart && slot.index < inventorySlotsStart) {
 			return getSlots(dispenserSlotsStart, 9, false);
 		}
 		
 		if(action == InventoryAction.MOVE_ALL) {
-			if(slot.id >= inventorySlotsStart && slot.id < hotbarSlotsStart) {
+			if(slot.index >= inventorySlotsStart && slot.index < hotbarSlotsStart) {
 				return getSlots(inventorySlotsStart, 27, false);
 			}
-			if(slot.id >= hotbarSlotsStart) {
+			if(slot.index >= hotbarSlotsStart) {
 				return getSlots(hotbarSlotsStart, 9, false);
 			}
 		}
 		if(action == InventoryAction.MOVE_SIMILAR) {
-			if(slot.id >= inventorySlotsStart) {
+			if(slot.index >= inventorySlotsStart) {
 				return getSlots(inventorySlotsStart, 36, false);
 			}
 		}
@@ -67,8 +68,8 @@ public class ContainerDispenser extends Container {
 	}
 
 	@Override
-	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, EntityPlayer player) {
-		if(slot.id >= dispenserSlotsStart && slot.id < inventorySlotsStart) {
+	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+		if(slot.index >= dispenserSlotsStart && slot.index < inventorySlotsStart) {
 			return getSlots(inventorySlotsStart, 36, false);
 		}else {
 			return getSlots(dispenserSlotsStart, 9, false);
diff --git a/src/main/java/net/minecraft/core/player/inventory/ContainerTrommel.java b/src/main/java/net/minecraft/core/player/inventory/menu/TrommelMenu.java
similarity index 67%
rename from src/main/java/net/minecraft/core/player/inventory/ContainerTrommel.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/TrommelMenu.java
index 40170fb14..843f95aa9 100644
--- a/src/main/java/net/minecraft/core/player/inventory/ContainerTrommel.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/TrommelMenu.java
@@ -1,22 +1,23 @@
-package net.minecraft.core.player.inventory;
+package net.minecraft.core.player.inventory.menu;
 
 import java.util.List;
 
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.block.entity.TileEntityTrommel;
+import net.minecraft.core.block.entity.TrommelBlockEntity;
 
-import net.minecraft.core.crafting.ICrafting;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.crafting.ContainerListener;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.player.inventory.container.Inventory;
 import net.minecraft.core.player.inventory.slot.Slot;
 
-public class ContainerTrommel extends Container {
+public class TrommelMenu extends AbstractContainerMenu {
 
-	private TileEntityTrommel trommel;
+	private TrommelBlockEntity trommel;
 	private int cookTime = 0;
 	private int burnTime = 0;
 	private int itemBurnTime = 0;
 
-	public ContainerTrommel(InventoryPlayer inventoryplayer, TileEntityTrommel tileEntityTrommel) {
+	public TrommelMenu(Inventory inventoryplayer, TrommelBlockEntity tileEntityTrommel) {
 		trommel = tileEntityTrommel;
 		
 		// Item Slots
@@ -39,10 +40,10 @@ public class ContainerTrommel extends Container {
 	}
 
 	@Override
-	public void updateInventory() {
-		super.updateInventory();
-		for (int i = 0; i < crafters.size(); i++) {
-			ICrafting icrafting = (ICrafting) crafters.get(i);
+	public void broadcastChanges() {
+		super.broadcastChanges();
+		for (int i = 0; i < containerListeners.size(); i++) {
+			ContainerListener icrafting = (ContainerListener) containerListeners.get(i);
 			if(cookTime != trommel.itemPopTime) {
 				icrafting.updateCraftingInventoryInfo(this, 0, trommel.itemPopTime);
 			}
@@ -60,7 +61,7 @@ public class ContainerTrommel extends Container {
 	}
 
 	@Override
-	public void updateClientProgressBar(int id, int value) {
+	public void setData(int id, int value) {
 		if(id == 0) {
 			trommel.itemPopTime = (int) value;
 		}
@@ -73,8 +74,8 @@ public class ContainerTrommel extends Container {
 	}
 
 	@Override
-	public boolean isUsableByPlayer(EntityPlayer entityplayer) {
-		return trommel.canInteractWith(entityplayer);
+	public boolean stillValid(Player entityplayer) {
+		return trommel.stillValid(entityplayer);
 	}
 	
 	/*
@@ -85,25 +86,25 @@ public class ContainerTrommel extends Container {
 	 */
 
 	@Override
-	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, EntityPlayer player) {
-		if(slot.id >= 0 && slot.id <= 3) {
+	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+		if(slot.index >= 0 && slot.index <= 3) {
 			return getSlots(0, 4, false);
 		}
-		if(slot.id == 4) {
+		if(slot.index == 4) {
 			return getSlots(4, 1, false);
 		}
 		if(action == InventoryAction.MOVE_ALL) {
-			if(slot.id >= 5 && slot.id <= 31) {
+			if(slot.index >= 5 && slot.index <= 31) {
 				// Main Inventory
 				return getSlots(5, 27, false);
 			}
-			if(slot.id >= 32 && slot.id <= 40) {
+			if(slot.index >= 32 && slot.index <= 40) {
 				// Hotbar
 				return getSlots(32, 9, false);
 			}
 		}
 		if(action == InventoryAction.MOVE_SIMILAR) {
-			if(slot.id >= 5 && slot.id <= 40) {
+			if(slot.index >= 5 && slot.index <= 40) {
 				// Full Inventory
 				return getSlots(5, 36, false);
 			}
@@ -112,12 +113,12 @@ public class ContainerTrommel extends Container {
 	}
 
 	@Override
-	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, EntityPlayer player) {
-		if(slot.id >= 0 && slot.id <= 4) {
+	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+		if(slot.index >= 0 && slot.index <= 4) {
 			// Item and Fuel Slots
 			return getSlots(5, 36, false); // Into Inventory
 		}
-		if(slot.id >= 5 && slot.id <= 40) {
+		if(slot.index >= 5 && slot.index <= 40) {
 			if(target == 1) {
 				return getSlots(0, 4, false); // Into Item Slots
 			}
@@ -125,11 +126,11 @@ public class ContainerTrommel extends Container {
 				return getSlots(4, 1, false); // Into Fuel Slot
 			}
 			
-			if(slot.id >= 5 && slot.id <= 31) {
+			if(slot.index >= 5 && slot.index <= 31) {
 				// Main Inventory
 				return getSlots(32, 9, false); // Into hotbar
 			}
-			if(slot.id >= 32 && slot.id <= 40) {
+			if(slot.index >= 32 && slot.index <= 40) {
 				// Hotbar
 				return getSlots(5, 27, false); // Into Inventory
 			}
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java b/src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java
new file mode 100644
index 000000000..f5a38946f
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java
@@ -0,0 +1,95 @@
+package net.minecraft.core.player.inventory.slot;
+
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.IArmorItem;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.block.BlockItem;
+import net.minecraft.core.player.inventory.container.Inventory;
+import net.minecraft.core.player.inventory.menu.InventoryMenu;
+import net.minecraft.core.player.inventory.container.Container;
+
+public class ArmorSlot extends Slot
+{
+    public static String[] armorOutlines = new String[]{
+            "minecraft:item/armor_helmet_outline",
+            "minecraft:item/armor_chestplate_outline",
+            "minecraft:item/armor_leggings_outline",
+            "minecraft:item/armor_boots_outline"
+    };
+
+    final int armorType;
+    final InventoryMenu menu;
+
+    public ArmorSlot(InventoryMenu menu, Container container, int index, int x, int y, int armorType)
+    {
+        super(container, index, x, y);
+        this.menu = menu;
+        this.armorType = armorType;
+    }
+
+    @Override
+	public int getMaxStackSize()
+    {
+        return 1;
+    }
+
+    @Override
+	public boolean mayPlace(ItemStack itemstack)
+    {
+        if(itemstack.getItem() instanceof IArmorItem)
+        {
+            return ((IArmorItem)itemstack.getItem()).getArmorPiece() == armorType;
+        }
+        if(itemstack.getItem() instanceof BlockItem)
+        {
+            return armorType == IArmorItem.PIECE_HEAD;
+        }
+        else
+        {
+            return false;
+        }
+    }
+    
+    @Override
+	public void setChanged()
+    {
+        super.setChanged();
+        
+        int count = 0;
+        
+        for (int i = 0; i < menu.slots.size(); i++)
+        {
+        	if (menu.slots.get(i) instanceof ArmorSlot)
+        	{
+        		ItemStack stack = menu.slots.get(i).getItem();
+        		if (stack != null && (stack.itemID == Items.ARMOR_BOOTS_CHAINMAIL.id || stack.itemID == Items.ARMOR_HELMET_CHAINMAIL.id || stack.itemID == Items.ARMOR_CHESTPLATE_CHAINMAIL.id || stack.itemID == Items.ARMOR_LEGGINGS_CHAINMAIL.id))
+				{
+        			count++;
+				}
+        	}
+        }
+        
+        if (count == 4)
+        {
+        	menu.inventory.player.triggerAchievement(Achievements.GET_CHAINMAIL);
+        }
+        
+        if (getItem() != null && container instanceof Inventory) {
+            Player player = ((Inventory) container).player;
+            player.world.playSoundAtEntity(player, player, "random.equip", 2f, 1f);
+        }
+    }
+
+    public void set(final ItemStack itemstack)
+    {
+        super.set(itemstack);
+    }
+
+    @Override
+	public String getItemIcon()
+    {
+        return armorOutlines[armorType];
+    }
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/CreativeSlot.java b/src/main/java/net/minecraft/core/player/inventory/slot/CreativeSlot.java
new file mode 100644
index 000000000..089368bc7
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/CreativeSlot.java
@@ -0,0 +1,76 @@
+package net.minecraft.core.player.inventory.slot;
+
+import net.minecraft.core.item.ItemStack;
+
+public class CreativeSlot extends Slot
+{
+	public ItemStack item;
+
+	public CreativeSlot(final int index, final int x, final int y, final ItemStack item)
+	{
+		super(null, index, x, y);
+		this.item = item;
+	}
+
+
+	@Override
+	public ItemStack remove(final int i)
+	{
+		if (item == null)
+		{
+			return null;
+		}
+		final ItemStack newStack = item.copy();
+		return newStack;
+	}
+
+	@Override
+	public boolean hasItem()
+	{
+		return item != null;
+	}
+
+	@Override
+	public int getMaxStackSize()
+	{
+		return 64;
+	}
+
+	@Override
+	public ItemStack getItem()
+	{
+		if (item == null)
+		{
+			return null;
+		}
+        return item.copy();
+	}
+
+	@Override
+	public void onTake(final ItemStack itemstack)
+	{
+    }
+
+	@Override
+	public void setChanged()
+	{
+		return;
+	}
+
+	@Override
+	public void set(final ItemStack itemstack)
+	{
+		return;
+	}
+	
+	@Override
+	public boolean enableDragAndPickup() {
+		return false;
+	}
+	
+	@Override
+	public boolean allowItemInteraction() {
+		return false;
+	}
+
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/DyeSlot.java b/src/main/java/net/minecraft/core/player/inventory/slot/DyeSlot.java
new file mode 100644
index 000000000..141f358e9
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/DyeSlot.java
@@ -0,0 +1,27 @@
+package net.minecraft.core.player.inventory.slot;
+
+import net.minecraft.core.item.Items;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.player.inventory.container.Container;
+
+public class DyeSlot extends Slot {
+
+	public DyeSlot(final Container inventory, final int id, final int x, final int y) {
+		super(inventory, id, x, y);
+	}
+
+	@Override
+	public boolean mayPlace(final ItemStack itemstack) {
+		return itemstack != null && itemstack.itemID == Items.DYE.id;
+	}
+
+	@Override
+	public int getMaxStackSize() {
+		return 1;
+	}
+	
+	@Override
+	public boolean allowItemInteraction() {
+		return false;
+	}
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/FurnaceSlot.java b/src/main/java/net/minecraft/core/player/inventory/slot/FurnaceSlot.java
new file mode 100644
index 000000000..9374f1648
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/FurnaceSlot.java
@@ -0,0 +1,55 @@
+package net.minecraft.core.player.inventory.slot;
+
+
+// Referenced classes of package net.minecraft.src:
+//            Slot, Player, ItemStack, Item,
+//            Achievements, IInventory
+
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.player.inventory.container.Container;
+
+public class FurnaceSlot extends Slot
+{
+
+    public FurnaceSlot(Player player, Container container, int index, int x, int y)
+    {
+        super(container, index, x, y);
+        thePlayer = player;
+    }
+
+    @Override
+	public boolean mayPlace(ItemStack itemstack)
+    {
+        return false;
+    }
+
+    @Override
+	public void onTake(ItemStack itemstack)
+    {
+        itemstack.onCrafting(thePlayer.world, thePlayer);
+        if(itemstack.itemID == Items.INGOT_IRON.id)
+        {
+            thePlayer.addStat(Achievements.ACQUIRE_IRON, 1);
+        }
+        if(itemstack.itemID == Items.FOOD_FISH_COOKED.id)
+        {
+            thePlayer.addStat(Achievements.COOK_FISH, 1);
+        }
+        super.onTake(itemstack);
+    }
+    
+    @Override
+    public boolean enableDragAndPickup() {
+    	return false;
+    }
+    
+    @Override
+    public boolean allowItemInteraction() {
+    	return false;
+    }
+
+    private Player thePlayer;
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/SlotGuidebook.java b/src/main/java/net/minecraft/core/player/inventory/slot/GuidebookSlot.java
similarity index 74%
rename from src/main/java/net/minecraft/core/player/inventory/slot/SlotGuidebook.java
rename to src/main/java/net/minecraft/core/player/inventory/slot/GuidebookSlot.java
index 5f80f95ac..631e25bc5 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/SlotGuidebook.java
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/GuidebookSlot.java
@@ -1,20 +1,21 @@
 package net.minecraft.core.player.inventory.slot;
 
-import net.minecraft.client.entity.player.EntityPlayerSP;
+import net.minecraft.client.entity.player.LocalPlayer;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.gamemode.Gamemode;
 
 import java.util.List;
 import java.util.Random;
 
-public class SlotGuidebook extends Slot
+public class GuidebookSlot extends Slot
 {
 	public ItemStack item;
 	public RecipeSymbol symbol;
@@ -22,10 +23,10 @@ public class SlotGuidebook extends Slot
 	public int recipeIndex = 0;
 	public int recipeAmount = 0;
 	public boolean isOutput = false;
-	public SlotGuidebook(final int id, final int x, final int y, final RecipeSymbol symbol, final boolean discovered, final RecipeEntryBase<?,?,?> recipe)
+	public GuidebookSlot(final int id, final int x, final int y, final RecipeSymbol symbol, final boolean discovered, final RecipeEntryBase<?,?,?> recipe)
 	{
 		super(null, id, x, y);
-		this.id = id;
+		this.index = id;
 		this.symbol = symbol;
 		if(symbol != null && symbol.getItemGroup() != null){
 			showRandomItem();
@@ -42,7 +43,7 @@ public class SlotGuidebook extends Slot
 
 
 	@Deprecated
-	public SlotGuidebook(final int id, final int x, final int y, final RecipeSymbol symbol, final boolean discovered)
+	public GuidebookSlot(final int id, final int x, final int y, final RecipeSymbol symbol, final boolean discovered)
 	{
 		super(null, id, x, y);
 		this.symbol = symbol;
@@ -55,47 +56,47 @@ public class SlotGuidebook extends Slot
 		this.recipe = null;
 	}
 
-	public SlotGuidebook setAsOutput(){
+	public GuidebookSlot setAsOutput(){
 		this.isOutput = true;
 		return this;
 	}
 
 	@Override
-	public ItemStack decrStackSize(final int i)
+	public ItemStack remove(final int i)
 	{
 		return null;
 	}
 
 	@Override
-	public boolean hasStack()
+	public boolean hasItem()
 	{
 		return item != null;
 	}
 
 	@Override
-	public int getSlotStackLimit()
+	public int getMaxStackSize()
 	{
 		return item.getMaxStackSize();
 	}
 
 	@Override
-	public ItemStack getStack()
+	public ItemStack getItem()
 	{
 		return item;
 	}
 
 	@Override
-	public void onPickupFromSlot(final ItemStack itemstack)
+	public void onTake(final ItemStack itemstack)
 	{
     }
 
 	@Override
-	public void onSlotChanged()
+	public void setChanged()
 	{
     }
 
 	@Override
-	public void putStack(final ItemStack itemstack)
+	public void set(final ItemStack itemstack)
 	{
     }
 
@@ -112,12 +113,12 @@ public class SlotGuidebook extends Slot
 			item = newItem;
 		}
 	}
-	public boolean getIsDiscovered(EntityPlayer player){
+	public boolean getIsDiscovered(Player player){
 		if (item == null || discovered) return true;
-		if (player instanceof EntityPlayerSP){
-			if (!((EntityPlayerSP) player).sender.minecraft.gameSettings.hideUndiscoveredItems.value) return true;
+		if (player instanceof LocalPlayer){
+			if (!((LocalPlayer) player).sender.minecraft.gameSettings.hideUndiscoveredItems.value) return true;
 		}
-		return player.getStat(StatList.pickUpItemStats[item.itemID]) > 0 || player.getGamemode() == Gamemode.creative;
+		return player.getStat(item.getItem().getStat(StatList.STAT_PICKED_UP)) > 0 || player.getGamemode() == Gamemode.creative;
 	}
 
 	public void scrollRecipe(){
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/ResultSlot.java b/src/main/java/net/minecraft/core/player/inventory/slot/ResultSlot.java
new file mode 100644
index 000000000..fb70a181d
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/ResultSlot.java
@@ -0,0 +1,80 @@
+package net.minecraft.core.player.inventory.slot;
+
+
+// Referenced classes of package net.minecraft.src:
+//            Slot, Player, ItemStack, Block,
+//            Achievements, Item, IInventory
+
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.tool.HoeToolItem;
+import net.minecraft.core.item.tool.PickaxeToolItem;
+import net.minecraft.core.item.tool.SwordToolItem;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
+
+public class ResultSlot extends Slot
+{
+	private final Container craftSlots;
+	private Player thePlayer;
+
+    public ResultSlot(Player player, Container craftSlots, Container container, int index, int x, int y)
+    {
+        super(container, index, x, y);
+        thePlayer = player;
+        this.craftSlots = craftSlots;
+    }
+
+    @Override
+	public boolean mayPlace(ItemStack itemstack)
+    {
+        return false;
+    }
+
+	@Override
+	public void onTake(ItemStack itemStack) {
+		itemStack.onCrafting(thePlayer.world, thePlayer);
+
+		Item item = itemStack.getItem();
+		
+		if(item.id == Blocks.WORKBENCH.id) thePlayer.addStat(Achievements.BUILD_WORKBENCH, 1);
+		if(item.id == Blocks.FURNACE_STONE_IDLE.id) thePlayer.addStat(Achievements.BUILD_FURNACE, 1);
+		if(item.id == Items.FOOD_BREAD.id) thePlayer.addStat(Achievements.MAKE_BREAD, 1);
+		if(item.id == Items.FOOD_CAKE.id) thePlayer.addStat(Achievements.BAKE_CAKE, 1);
+		if(item.id == Items.HANDCANNON_UNLOADED.id) thePlayer.addStat(Achievements.CRAFT_HANDCANNON, 1);
+		if(item instanceof HoeToolItem) thePlayer.addStat(Achievements.BUILD_HOE, 1);
+		if(item instanceof SwordToolItem) thePlayer.addStat(Achievements.BUILD_SWORD, 1);
+		if(item instanceof PickaxeToolItem) {
+			PickaxeToolItem itemToolPickaxe = (PickaxeToolItem) item;
+
+			if(itemToolPickaxe.getMaterial().getMiningLevel() > 0) {
+				thePlayer.addStat(Achievements.BUILD_BETTER_PICKAXE, 1);
+			}
+			
+			thePlayer.addStat(Achievements.BUILD_PICKAXE, 1);
+		}
+		if(itemStack.itemID == Items.ARMOR_BOOTS_CHAINMAIL.id
+				|| itemStack.itemID == Items.ARMOR_HELMET_CHAINMAIL.id
+				|| itemStack.itemID == Items.ARMOR_CHESTPLATE_CHAINMAIL.id
+				|| itemStack.itemID == Items.ARMOR_LEGGINGS_CHAINMAIL.id) {
+			thePlayer.addStat(Achievements.REPAIR_ARMOR, 1);
+		}
+
+		Registries.RECIPES.onCraftResult((CraftingContainer) craftSlots);
+	}
+    
+    @Override
+    public boolean enableDragAndPickup() {
+    	return false;
+    }
+    
+    @Override
+    public boolean allowItemInteraction() {
+    	return false;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java b/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
index d46c04380..75beacaa6 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
@@ -4,96 +4,96 @@ package net.minecraft.core.player.inventory.slot;
 //            IInventory, ItemStack
 
 import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.InventoryPlayer;
-import net.minecraft.core.player.inventory.IInventory;
+import net.minecraft.core.player.inventory.container.Inventory;
+import net.minecraft.core.player.inventory.container.Container;
 import org.jetbrains.annotations.Nullable;
 
 public class Slot
 {
-	protected final int slotIndex;
-	protected final IInventory inventory;
-	public int id;
-	public int xDisplayPosition;
-	public int yDisplayPosition;
+	protected final int slot;
+	protected final Container container;
+	public int index;
+	public int x;
+	public int y;
 	protected boolean discovered;
 
-	public Slot(final IInventory inventory, final int id, final int x, final int y)
+	public Slot(final Container container, final int index, final int x, final int y)
 	{
-		this.inventory = inventory;
-		slotIndex = id;
-		xDisplayPosition = x;
-		yDisplayPosition = y;
+		this.container = container;
+		slot = index;
+		this.x = x;
+		this.y = y;
 		discovered = true;
 	}
 
 	public void sortSlotInventory() {
-		if (inventory != null) {
-			inventory.sortInventory();
+		if (container != null) {
+			container.sortContainer();
 		}
 	}
 
-	public ItemStack decrStackSize(final int i)
+	public ItemStack remove(final int i)
 	{
-		return inventory.decrStackSize(slotIndex, i);
+		return container.removeItem(slot, i);
 	}
 
-	public @Nullable String getBackgroundIconId()
+	public @Nullable String getItemIcon()
 	{
 		return null;
 	}
 
-	public boolean hasStack()
+	public boolean hasItem()
 	{
-		return getStack() != null;
+		return getItem() != null;
 	}
 
-	public int getSlotStackLimit()
+	public int getMaxStackSize()
 	{
-		return inventory.getInventoryStackLimit();
+		return container.getMaxStackSize();
 	}
 
-	public ItemStack getStack()
+	public ItemStack getItem()
 	{
-		return inventory.getStackInSlot(slotIndex);
+		return container.getItem(slot);
 	}
 
-	public boolean isHere(final IInventory iinventory, final int i)
+	public boolean isAt(final Container container, final int i)
 	{
-		return iinventory == inventory && i == slotIndex;
+		return container == this.container && i == slot;
 	}
 
-	public boolean canPutStackInSlot(final ItemStack itemstack)
+	public boolean mayPlace(final ItemStack itemstack)
 	{
 		return true;
 	}
 
-	public void onPickupFromSlot(final ItemStack itemstack)
+	public void onTake(final ItemStack itemstack)
 	{
-		onSlotChanged();
+		setChanged();
 	}
 
-	public void onSlotChanged()
+	public void setChanged()
 	{
-		inventory.onInventoryChanged();
+		container.setChanged();
 	}
 
-	public IInventory getInventory() {
-		return inventory;
+	public Container getContainer() {
+		return container;
 	}
 
-	public void putStack(final ItemStack itemstack)
+	public void set(final ItemStack itemstack)
 	{
-		inventory.setInventorySlotContents(slotIndex, itemstack);
-		onSlotChanged();
+		container.setItem(slot, itemstack);
+		setChanged();
 
-		if (inventory instanceof InventoryPlayer)
+		if (container instanceof Inventory)
 		{
-			final InventoryPlayer inventoryPlayer = (InventoryPlayer) inventory;
+			final Inventory inventory = (Inventory) this.container;
 
 			if(itemstack != null)
-				inventoryPlayer.player.addStat(StatList.pickUpItemStats[itemstack.itemID], 1);
+				inventory.player.addStat(itemstack.getItem().getStat(StatList.STAT_PICKED_UP), 1);
 
 		}
 	}
@@ -105,10 +105,8 @@ public class Slot
 	public boolean allowItemInteraction() {
 		return true;
 	}
-	public void setDiscovered(Boolean flag){
-		discovered = flag;
-	}
-	public boolean getIsDiscovered(EntityPlayer player){
+
+	public boolean getIsDiscovered(Player player){
 		return discovered;
 	}
 
diff --git a/src/main/java/net/minecraft/core/sound/BlockSounds.java b/src/main/java/net/minecraft/core/sound/BlockSounds.java
index 149c96e10..f7e38683b 100644
--- a/src/main/java/net/minecraft/core/sound/BlockSounds.java
+++ b/src/main/java/net/minecraft/core/sound/BlockSounds.java
@@ -7,6 +7,7 @@ public abstract class BlockSounds
     public static final BlockSound GRAVEL = new BlockSound("step.gravel", "step.gravel", 1.0F, 1.0F);
     public static final BlockSound GRASS = new BlockSound("step.grass", "step.grass", 1.0F, 1.0F);
     public static final BlockSound STONE = new BlockSound("step.stone", "step.stone", 1.0F, 1.0F);
+    public static final BlockSound PERMAFROST = new BlockSound("step.permafrost", "step.permafrost", 1.0F, 1.0F);
     public static final BlockSound METAL = new BlockSound("step.stone", "step.stone", 1.0F, 1.5F);
     public static final BlockSound GLASS = new BlockSound("step.stone", "random.glass", 1.0F, 1.0F);
     public static final BlockSound CLOTH = new BlockSound("step.cloth", "step.cloth", 1.0F, 1.0F);
diff --git a/src/main/java/net/minecraft/core/util/HardIllegalArgumentException.java b/src/main/java/net/minecraft/core/util/HardIllegalArgumentException.java
new file mode 100644
index 000000000..a3fc96628
--- /dev/null
+++ b/src/main/java/net/minecraft/core/util/HardIllegalArgumentException.java
@@ -0,0 +1,26 @@
+package net.minecraft.core.util;
+
+public class HardIllegalArgumentException extends Exception{
+
+    public HardIllegalArgumentException() {
+        super();
+    }
+
+    public HardIllegalArgumentException(String message) {
+        super(message);
+    }
+
+    public HardIllegalArgumentException(String message, Throwable cause) {
+        super(message, cause);
+    }
+
+    public HardIllegalArgumentException(Throwable cause) {
+        super(cause);
+    }
+
+    protected HardIllegalArgumentException(String message, Throwable cause,
+                                           boolean enableSuppression,
+                                           boolean writableStackTrace) {
+        super(message, cause, enableSuppression, writableStackTrace);
+    }
+}
